<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from lic.texi on 28 April 1999 -->

<TITLE>The Linear Inequality Calculator - Array Reshape</TITLE>
<link href="lic_17.html" rel=Next>
<link href="lic_15.html" rel=Previous>
<link href="lic_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_15.html">previous</A>, <A HREF="lic_17.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC16" HREF="lic_toc.html#TOC16">Array Reshape</A></H3>


<PRE>
dimension A(100, 100)
  
do i = 1, 100
   do j = 1, 25
      call foo(A(10, i))
      A(j, i) = 
   enddo
enddo

subroutine foo(B)
dimension B(50)

do k = 30, 50
    = B(k) 
enddo
</PRE>

<P>
<A NAME="IDX179"></A>

</P>
<P>
The access <SAMP>`B(k)'</SAMP> and the access <SAMP>`A(p, q)'</SAMP> may be dependent,
but without knowing the relationship between the accesses it is
difficult to find this fact. In this script the relationship between two
accesses is found.  Then the existence of a dependence between two
references is checked.
<A NAME="IDX180"></A>
<A NAME="IDX181"></A>
<A NAME="IDX182"></A>
<A NAME="IDX183"></A>
<A NAME="IDX184"></A>

</P>

<PRE>
// base = A(10, i)
#callA = [ 100*i + 10 = base  ]  
// acc = A(j, i)
#accessA = [ 100 * i + j = acc ]
#dimA = [ 1 &#60;= j &#60;= 100
          1 &#60;= i &#60;= 100 ]

// acc = B(k) + base
#accessB = [ acc = k + base ]  
#dimB = [ 1 &#60;= k &#60;= 50 ]

#full = {callA, accessA, dimA, accessB, dimB}

#full = full.order(i j k base acc)
#full = full.project(acc)
#full = full.project(base)
// relationship
full.simplify()

#iterA = [ 1 &#60;= i &#60;= 100 
           1 &#60;= j &#60;= 25 ]
#iterB = [ 30 &#60;= k &#60;= 50 ]

#full = {iterA, callA, accessA, dimA, iterB, accessB, dimB}
// is dependent
full.realsol()

end
</PRE>

<P>
<A NAME="IDX185"></A>

</P>
<P>
The printout of the example session:

</P>

<PRE>
csh&#62; lic -c
Rapid Prototyping System for Code Generation
&#62; &#60; example7

// base = A(10, i)
#callA = [ 100*i + 10 = base  ]
// acc = A(j, i)
#accessA = [ 100 * i + j = acc ]
#dimA = [ 1 &#60;= j &#60;= 100
          1 &#60;= i &#60;= 100 ]

// acc = B(k) + base
#accessB = [ acc = k + base ]
#dimB = [ 1 &#60;= k &#60;= 50 ]

#full = {callA, accessA, dimA, accessB, dimB}

#full = full.order(i j k base acc)
#full = full.project(acc)
#full = full.project(base)
// relationship
full.simplify()
-1+i &#62;= 0
100-i &#62;= 0
60-j &#62;= 0
-11+j &#62;= 0
10-j+k &#62;= 0
-10+j-k &#62;= 0

#iterA = [ 1 &#60;= i &#60;= 100
           1 &#60;= j &#60;= 25 ]
#iterB = [ 30 &#60;= k &#60;= 50 ]

#full = {iterA, callA, accessA, dimA, iterB, accessB, dimB}
// is dependent
full.realsol()
0

end
&#62; quit
done(0)

csh&#62;
</PRE>

<P>
<A NAME="IDX186"></A>

</P>
<P>
From the simplified system we find that <SAMP>`A(k+25, i)'</SAMP> is the same as
<SAMP>`B(k)'</SAMP>. Thus <SAMP>`A(k+25, i)'</SAMP> can be used instead of <SAMP>`B(k)'</SAMP>
in checking the dependence between two accesses. 

</P>
<P>
After formulating the dependence question by incorporating the loop
bounds we find that the two accesses are independent.

</P>

<P><HR><P>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_15.html">previous</A>, <A HREF="lic_17.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
</BODY>
</HTML>
